<template>
  <q-list>
    <q-toolbar class="bg-primary text-white shadow-2">
      <q-toolbar-title role="heading">Tabellen
        <q-badge align="top" outline v-if="tables_filtered">
          {{ tables_filtered.length }}
        </q-badge>
        <q-badge align="top" outline v-else>0</q-badge>
      </q-toolbar-title>
    </q-toolbar>
    <q-card>
      <q-card-section>
        <q-input label="filter" v-model="search_value" title="Filter tabellen" autofocus>
          <template v-slot:prepend>
            <q-icon name="filter_alt"/>
          </template>
        </q-input>
      </q-card-section>
    </q-card>
    <div class="scroll_list">
      <q-item clickable v-ripple
              v-for="table in tables_filtered"
              v-bind:id="table.id"
              v-bind:key="table.id"
              :ref="table.id"
              active-class="active"
              :to="{name: 'table_detail', params: {table_id: table.id, nt_version: nt_version}}"
              :class="{active: table.id === current_table.id}">
        <q-item-section v-html="show_label(table)"></q-item-section>
      </q-item>
    </div>
    <q-inner-loading :showing="typeof this.tables=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.tables=='undefined'"></q-circular-progress>
    </q-inner-loading>
  </q-list>
</template>

<script>
import {api} from 'boot/axios'
import _ from "lodash"
import SharedMethods from "components/SharedMethods";

export default {
  name: "TableList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    this.fetchData()
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  data() {
    return {
      tables: undefined,
      current_table: Object,
      search_value: '',
      language_switch: undefined
    }
  },
  watch: {
    dts_name: function () {
      this.fetchData()
    },
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  },
  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/tables", {params: {nt_version: this.nt_version, full: 0}})
        .then(response => {
          this.tables = response.data
          if (this.tables.length && this.$route.fullPath.endsWith('tables')) {
            this.$router.push({name: 'table_detail', replace: true, params: {table_id: this.tables[0].id}})
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.references = []
        })

    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  },
  computed: {
    tables_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.tables.filter(table => this.get_label(table).toLowerCase().includes(this.search_value.toLowerCase()))
      } else {
        return this.tables
      }
    }
  }

}
</script>

<style scoped lang="scss">
.active {
  background: $list_selected_bg;
  color: white;
  opacity: 0.9;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

</style>
